-- DAWS Package file B for DCSW 1.5
local MainVersion = "0"
local SubVersion = "2"
local Build = "2260"


-- THANKS TO (cronological order):
	-- Rider (AMVI)
	-- Grimes (ED community)
	-- MBot (ED community)
	-- xcom (ED community)
	-- Ian (ED community)
	-- vicx (ED community)
	-- Pikey (ED community)
	-- ESAC_Matador (ED community)

	-- USER VARIABLES
	VehicleDamageStatus 			= AIEvehicledamageDP --false -- if set to "True" it will modify ground vehicle status to simulate proximity damage by commanding AI modification
	DynamicGroundWar				= false
	EA_suppression 					= AIEsuppressionDP --true
	EA_infantry_carrier 			= AIEinfantryCarrierDP -- true 
	EA_infantry_carrier_Perc		= AIEinfantryCarrierPercDP -- 100 -- %of units dismountable
	EA_artillery 					= false -- false
	EA_baseIADS						= false -- false
	--EA_infantry_carrier_SMdata 		= true

	--#####################################################		
	--### RoadMap #########################################
	--#####################################################		
	
	--[[
		1.0 - VehicleDamageStatus & DynamicGroundWar modules
		1.1 - Infantry carring module
		1.2 - Logistic module
		1.3 - Enhanced AI module
		2.0? - Air war module

	--]]--




	
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################

	-- local function copy
	local base 						= _G
	local require 					= base.require
	local table 					= base.table
	local math 						= base.math
	local string					= base.string
	local pairs 					= base.pairs
	local ipairs 					= base.ipairs
	local print 					= base.print
	local io 						= base.io
	local lfs 						= base.lfs
	local os 						= base.os
	local zip 						= minizip
	local loadstring 				= base.loadstring
	--]]--
	
	-- common directory listing
	local mistdirectory 			= mistdirectoryDP -- lfs.currentdir() .. "AMVI/Common/Code/"
	local moddirectory 				= moddirectoryAE 	-- lfs.currentdir() .. "AMVI/AIEnhancement/"
	local debugdirectory  			= debugdirectoryAE	--lfs.currentdir() .. "AMVI/AIEnhancement/Debug/"
	local missionfilesdirectory 	= missionfilesdirectoryDP -- lfs.writedir() .. "Missions/"
	local logsdirectory				= logsdirectoryDP -- lfs.writedir() .. "Logs/"
	
	-- common export variables
	local exportfiletype 			= ".csv"
	--reportfiletype 				= ".doc"
	local configfiletype 			= ".csv"
	local tss 						= ";"
	
	--##### INTERNAL VARIABLES
	local debugProcess 				= false -- print information log in dcs.log

	--##### EXTERNAL VARIABLES (DAWS Package integration)
	DAWS_AIE_running				= true
	
	--improved random
	do
	   local oldrandom = math.random
	   local randomtable
	   math.random = function ()
		  if randomtable == nil then
			 randomtable = {}
			 for i = 1, 97 do
				randomtable[i] = oldrandom()
			 end
		  end
		  local x = oldrandom()
		  local i = 1 + math.floor(97*x)
		  x, randomtable[i] = randomtable[i], x
		  return x
	   end
	end	

-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################

	
	-- imported basicSerialize
	function IntegratedbasicSerialize(s)
		if s == nil then
			return "\"\""
		else
			if ((type(s) == 'number') or (type(s) == 'boolean') or (type(s) == 'function') or (type(s) == 'table') or (type(s) == 'userdata') ) then
				return tostring(s)
			elseif type(s) == 'string' then
				return string.format('%q', s)
			end
		end
	end
	--]]--

	-- imported slmod.serialize
	function Integratedserialize(name, value, level)
		-----Based on ED's serialize_simple2
		local basicSerialize = function (o)
		  if type(o) == "number" then
			return tostring(o)
		  elseif type(o) == "boolean" then
			return tostring(o)
		  else -- assume it is a string
			return IntegratedbasicSerialize(o)
		  end
		end

		local serialize_to_t = function (name, value, level)
		----Based on ED's serialize_simple2


		  local var_str_tbl = {}
		  if level == nil then level = "" end
		  if level ~= "" then level = level.."  " end

		  table.insert(var_str_tbl, level .. name .. " = ")

		  if type(value) == "number" or type(value) == "string" or type(value) == "boolean" then
			table.insert(var_str_tbl, basicSerialize(value) ..  ",\n")
		  elseif type(value) == "table" then
			  table.insert(var_str_tbl, "\n"..level.."{\n")

			  for k,v in pairs(value) do -- serialize its fields
				local key
				if type(k) == "number" then
				  key = string.format("[%s]", k)
				else
				  key = string.format("[%q]", k)
				end

				table.insert(var_str_tbl, Integratedserialize(key, v, level.."  "))

			  end
			  if level == "" then
				table.insert(var_str_tbl, level.."} -- end of "..name.."\n")

			  else
				table.insert(var_str_tbl, level.."}, -- end of "..name.."\n")

			  end
		  else
			print("Cannot serialize a "..type(value))
		  end
		  return var_str_tbl
		end

		local t_str = serialize_to_t(name, value, level)

		return table.concat(t_str)
	end
	--]]--

	-- imported slmod.serializeWithCycles
	function IntegratedserializeWithCycles(name, value, saved)
		local basicSerialize = function (o)
			if type(o) == "number" then
				return tostring(o)
			elseif type(o) == "boolean" then
				return tostring(o)
			else -- assume it is a string
				return IntegratedbasicSerialize(o)
			end
		end

		local t_str = {}
		saved = saved or {}       -- initial value
		if ((type(value) == 'string') or (type(value) == 'number') or (type(value) == 'table') or (type(value) == 'boolean')) then
			table.insert(t_str, name .. " = ")
			if type(value) == "number" or type(value) == "string" or type(value) == "boolean" then
				table.insert(t_str, basicSerialize(value) ..  "\n")
			else

				if saved[value] then    -- value already saved?
					table.insert(t_str, saved[value] .. "\n")
				else
					saved[value] = name   -- save name for next time
					table.insert(t_str, "{}\n")
					for k,v in pairs(value) do      -- save its fields
						local fieldname = string.format("%s[%s]", name, basicSerialize(k))
						table.insert(t_str, IntegratedserializeWithCycles(fieldname, v, saved))
					end
				end
			end
			return table.concat(t_str)
		else
			return ""
		end
	end
	--]]--

	-- imported slmod.serializeWithCycles
	function IntegratedGetUnzippedMission(t_window) -- OK

		t_window = t_window or 3600 -- default: if t_window not specified, look at all files newer than 1 hour
		local run_t = os.time()
		local mis_path, mis_t
		local path =  lfs.tempdir()

		for file in lfs.dir(path) do
			if file and file:sub(1,1) == '~' then
				local fpath = path .. '/' .. file
				local mod_t = lfs.attributes(fpath, 'modification')
				if mod_t and math.abs(run_t - mod_t) <= t_window then
					local f = io.open(fpath, 'r')
					if f then
						local fline = f:read()
						if fline and fline:sub(1,7) == 'mission' and (not mis_t or mod_t > mis_t) then -- found an unzipped mission file, and either none was found before or this is the most recent
							mis_t = mod_t
							mis_path = fpath
						end
						f:close()
					end
				end
			end
		end

		if mis_path then -- a mission file was found
			local f = io.open(mis_path, 'r')
			if f then
				local mission = f:read('*all')
				f:close()

				if debugProcess == true then
					env.info(("--> mission file in tempdir opened"))	  -- Printa solo conferma che ha letto la variabile mission.
				end

				return mission
			end
		end
	end
	--]]--
	
	-- old mist.utils.tableShow
	DAWS.tableShow = function(tbl, loc, indent, tableshow_tbls) --based on serialize_slmod, this is a _G serialization
		tableshow_tbls = tableshow_tbls or {} --create table of tables
		loc = loc or ""
		indent = indent or ""
		if type(tbl) == 'table' then --function only works for tables!
			tableshow_tbls[tbl] = loc
			
			local tbl_str = {}

			tbl_str[#tbl_str + 1] = indent .. '{\n'
			
			for ind,val in pairs(tbl) do -- serialize its fields
				if type(ind) == "number" then
					tbl_str[#tbl_str + 1] = indent 
					tbl_str[#tbl_str + 1] = loc .. '['
					tbl_str[#tbl_str + 1] = tostring(ind)
					tbl_str[#tbl_str + 1] = '] = '
				else
					tbl_str[#tbl_str + 1] = indent 
					tbl_str[#tbl_str + 1] = loc .. '['
					tbl_str[#tbl_str + 1] = IntegratedbasicSerialize(ind)
					tbl_str[#tbl_str + 1] = '] = '
				end
						
				if ((type(val) == 'number') or (type(val) == 'boolean')) then
					tbl_str[#tbl_str + 1] = tostring(val)
					tbl_str[#tbl_str + 1] = ',\n'		
				elseif type(val) == 'string' then
					tbl_str[#tbl_str + 1] = IntegratedbasicSerialize(val)
					tbl_str[#tbl_str + 1] = ',\n'
				elseif type(val) == 'nil' then -- won't ever happen, right?
					tbl_str[#tbl_str + 1] = 'nil,\n'
				elseif type(val) == 'table' then
					if tableshow_tbls[val] then
						tbl_str[#tbl_str + 1] = tostring(val) .. ' already defined: ' .. tableshow_tbls[val] .. ',\n'
					else
						tableshow_tbls[val] = loc ..  '[' .. IntegratedbasicSerialize(ind) .. ']'
						tbl_str[#tbl_str + 1] = tostring(val) .. ' '
						tbl_str[#tbl_str + 1] = DAWS.tableShow(val,  loc .. '[' .. IntegratedbasicSerialize(ind).. ']', indent .. '    ', tableshow_tbls)
						tbl_str[#tbl_str + 1] = ',\n'  
					end
				elseif type(val) == 'function' then
					if debug and debug.getinfo then
						local fcnname = tostring(val)
						local info = debug.getinfo(val, "S")
						if info.what == "C" then
							tbl_str[#tbl_str + 1] = string.format('%q', fcnname .. ', C function') .. ',\n'
						else 
							if (string.sub(info.source, 1, 2) == [[./]]) then
								tbl_str[#tbl_str + 1] = string.format('%q', fcnname .. ', defined in (' .. info.linedefined .. '-' .. info.lastlinedefined .. ')' .. info.source) ..',\n'
							else
								tbl_str[#tbl_str + 1] = string.format('%q', fcnname .. ', defined in (' .. info.linedefined .. '-' .. info.lastlinedefined .. ')') ..',\n'
							end
						end
						
					else
						tbl_str[#tbl_str + 1] = 'a function,\n'	
					end
				else
					tbl_str[#tbl_str + 1] = 'unable to serialize value type ' .. IntegratedbasicSerialize(type(val)) .. ' at index ' .. tostring(ind)
				end
			end
			
			tbl_str[#tbl_str + 1] = indent .. '}'
			return table.concat(tbl_str)
		end
	end
	--]]--
	
	-- old mist.debug.dump_G
	DAWS.dumpTable = function(fname, tabledata)
		if lfs and io then
			local fdir = lfs.writedir() .. [[Logs\]] .. fname
			local f = io.open(fdir, 'w')
			f:write(DAWS.tableShow(tabledata))
			f:close()
		end
	end
	--]]--		


-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################

	if VehicleDamageStatus == true then
		if debugProcess == true then
			env.info(("loading VehicleDamageStatus pack ..."))
		end						
		dofile(moddirectory .. "DAWS_AIE_VehicleDamageStatus.lua")		
	end
	--]]--
	
	if DynamicGroundWar == true then
		if debugProcess == true then
			env.info(("loading DGW pack ..."))
		end						
		dofile(moddirectory .. "DAWS_DGW.lua")				
	end
	--]]--
	
	-- ### 1. enhanced suppression script ################
	if EA_suppression then
		if debugProcess == true then
			env.info(("loading EA Suppression pack ..."))
		end						
		dofile(moddirectory .. "DAWS_AIE_EA_suppression.lua")	
	end
	--]]--
		
	-- ### 2. dismount script ############################
	if EA_infantry_carrier then
		if debugProcess == true then
			env.info(("loading EA infantry_carrier pack ..."))
		end						
		dofile(moddirectory .. "DAWS_AIE_EA_infantry_carrier.lua")	
	end
	--]]--
	
	-- ### 3. enhanced sam logic script ##################
	if EA_baseIADS then
		if debugProcess == true then
			env.info(("loading EA IADS pack ..."))
		end						
		dofile(moddirectory .. "DAWS_AIE_EA_IADS.lua")	
	end
	--]]-- END IADS


	env.info(("DAWS AI Enhancement version: " .. MainVersion .. "." .. SubVersion .. "." .. Build .. " loaded"))
	-- ~=
	
