-- DAWS_Package for DCSW 1.5
local MainVersion = "1"
local SubVersion = "1"
local Build = "2265"

-- THANKS TO (cronological order):
	-- Rider (AMVI)
	-- Grimes (ED community)
	-- MBot (ED community)
	-- xcom (ED community)
	-- Ian (ED community)
	-- vicx (ED community)
	-- Pikey (ED community)
	-- ESAC_Matador (ED community)
	-- uboats (ED community)

-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
-- ################################################################################################################################
	
	-- local main start variables
	local Activate_SaveMission 		= true
	local Activate_AIenhancement 	= true
	
	
	-- local function copy
	local base 						= _G
	local require 					= base.require
	local table 					= base.table
	local math 						= base.math
	local pairs 					= base.pairs
	local ipairs 					= base.ipairs
	local print 					= base.print
	local io 						= base.io
	local lfs 						= base.lfs
	local os 						= base.os
	local zip 						= minizip
	local loadstring 				= base.loadstring
	local loadlib					= base.loadlib
	minizip 						= require('minizip')	
	
	-- local check variables
	local debugProcess 				= true
	mistdirectoryDP					= lfs.currentdir() .. "AMVI/Common/Code/"
	moddirectorySM 					= lfs.currentdir() .. "AMVI/SaveMission/"
	moddirectoryAE					= lfs.currentdir() .. "AMVI/AIEnhancement/"
	debugdirectorySM				= lfs.currentdir() .. "AMVI/SaveMission/Debug/"
	debugdirectoryAE				= lfs.currentdir() .. "AMVI/AIEnhancement/Debug/"
	missionfilesdirectoryDP 		= lfs.writedir() .. "Missions/"
	logsdirectoryDP					= lfs.writedir() .. "Logs/"

	-- create DAWS repository if not there
	if not DAWS then
		DAWS = {}
		if debugProcess == true then
			env.info(("DAWS not found, void table created"))
		end				
	end
	--]]--
	
	-- load mist if not already loaded
	if not mist then
		if debugProcess == true then
			env.info(("mist not found, will load at mission start"))
		end
		
		local actiMist = function()
			if not mist then
				env.info(("DAWS: mist still not there -> loading mist"))
				dofile(lfs.currentdir() .. "AMVI/Common/Code/" .. "mist.lua")
				if debugProcess == true then
					env.info(("mist loaded"))
				end
			end
		end
		timer.scheduleFunction(actiMist, {}, timer.getTime() + 0.01)   --   
		
	end		
	--]]--
	
	-- add options code
	dofile(lfs.writedir().."Config/".."options.lua")
	CreateStaticsDP 					= options["plugins"]["AMVI"]["CreateStatics"]
	HiddenStaticsDP 					= options["plugins"]["AMVI"]["HiddenStatics"]
	MapObjectPersitenceDP 				= options["plugins"]["AMVI"]["MapObjectPersitence"]
	KeepGroupsRoutesDP 					= options["plugins"]["AMVI"]["KeepGroupsRoutes"]
	AirUnitTrackedDP 					= options["plugins"]["AMVI"]["AirUnitTracked"]
	TrackAddedGroupsDP 					= options["plugins"]["AMVI"]["TrackAddedGroups"]
	TrackAddedInfantryDP 				= options["plugins"]["AMVI"]["TrackAddedInfantry"]
	timer_optionsDP 					= options["plugins"]["AMVI"]["timer_options"]  -- 1 is KeepContinousMission, 2 is UpdateSceneryDate
	theMessageStateDP 					= options["plugins"]["AMVI"]["theMessageState"]
	RadioMenuVariableDP 				= options["plugins"]["AMVI"]["RadioMenuVariable"]
	RadioMenuSingleGroupDP				= options["plugins"]["AMVI"]["RadioMenuSingleGroup"]
	AutoSaveEnableDP 					= options["plugins"]["AMVI"]["AutoSaveEnable"]
	--UseFixedPathDP 						= options["plugins"]["AMVI"]["UseFixedPath"]
	AIEsuppressionDP					= options["plugins"]["AMVI"]["AIEsuppression"]	
	AIEvehicledamageDP 					= options["plugins"]["AMVI"]["AIEvehicledamage"]
	AIEinfantryCarrierDP 				= options["plugins"]["AMVI"]["AIEinfantryCarrier"]
	AIEinfantryCarrierPercDP			= options["plugins"]["AMVI"]["AIEinfantryCarrierPerc"]
	AIEautoartilleryDP 					= options["plugins"]["AMVI"]["AIEautoartillery"]
	AIEbaseIADSDP 						= options["plugins"]["AMVI"]["AIEbaseIADS"]	
	KeepContinousMissionDP 				= nil
	UpdateSceneryDateDP					= nil
	FixedPathDP							= nil		
	
	-- adjust options multiple values
	if timer_optionsDP == 1 then -- timer_options == "default" or 
		KeepContinousMissionDP = true
		UpdateSceneryDateDP = false
		DAWS_SM_TimerSetting = "KeepContinousMission"
	else
		KeepContinousMissionDP = false
		UpdateSceneryDateDP = true
		DAWS_SM_TimerSetting = "UpdateSceneryDate"
	end
	--]]--
	
	--[[ debug check for options
	if debugProcess == true then
		if CreateStaticsDP then
			env.info(("DAWS option CreateStaticsDP is "..tostring(CreateStaticsDP)))	
		else
			env.info(("DAWS option CreateStaticsDP is nil"))
		end
		if HiddenStaticsDP then
			env.info(("DAWS option HiddenStaticsDP is "..tostring(HiddenStaticsDP)))	
		else
			env.info(("DAWS option HiddenStaticsDP is nil"))
		end		
		if MapObjectPersitenceDP then
			env.info(("DAWS option MapObjectPersitenceDP is "..tostring(MapObjectPersitenceDP)))	
		else
			env.info(("DAWS option MapObjectPersitenceDP is nil"))
		end
		if KeepGroupsRoutesDP then
			env.info(("DAWS option KeepGroupsRoutesDP is "..tostring(KeepGroupsRoutesDP)))	
		else
			env.info(("DAWS option KeepGroupsRoutesDP is nil"))
		end
		if AirUnitTrackedDP then
			env.info(("DAWS option AirUnitTrackedDP is "..tostring(AirUnitTrackedDP)))	
		else
			env.info(("DAWS option AirUnitTrackedDP is nil"))
		end
		if TrackAddedGroupsDP then
			env.info(("DAWS option TrackAddedGroupsDP is "..tostring(TrackAddedGroupsDP)))	
		else
			env.info(("DAWS option TrackAddedGroupsDP is nil"))
		end
		if TrackAddedInfantryDP then
			env.info(("DAWS option TrackAddedInfantryDP is "..tostring(TrackAddedInfantryDP)))	
		else
			env.info(("DAWS option TrackAddedInfantryDP is nil"))
		end
		if timer_optionsDP then
			env.info(("DAWS option timer_optionsDP is "..tostring(timer_optionsDP)))	
		else
			env.info(("DAWS option timer_optionsDP is nil"))
		end		
		if KeepContinousMissionDP then
			env.info(("DAWS option KeepContinousMissionDP is "..tostring(KeepContinousMissionDP)))	
		else
			env.info(("DAWS option KeepContinousMissionDP is nil"))
		end
		if UpdateSceneryDateDP then
			env.info(("DAWS option UpdateSceneryDateDP is "..tostring(UpdateSceneryDateDP)))	
		else
			env.info(("DAWS option UpdateSceneryDateDP is nil"))
		end
		if theMessageStateDP then
			env.info(("DAWS option theMessageStateDP is "..tostring(theMessageStateDP)))	
		else
			env.info(("DAWS option theMessageStateDP is nil"))
		end
		if RadioMenuVariableDP then
			env.info(("DAWS option RadioMenuVariableDP is "..tostring(RadioMenuVariableDP)))	
		else
			env.info(("DAWS option RadioMenuVariableDP is nil"))
		end		
		if RadioMenuSingleGroupDP then
			env.info(("DAWS option RadioMenuSingleGroupDP is "..tostring(RadioMenuSingleGroupDP)))	
		else
			env.info(("DAWS option RadioMenuSingleGroupDP is nil"))
		end			
		if AutoSaveEnableDP then
			env.info(("DAWS option AutoSaveEnableDP is "..tostring(AutoSaveEnableDP)))	
		else
			env.info(("DAWS option AutoSaveEnableDP is nil"))
		end			
		if FixedPathDP then
			env.info(("DAWS option FixedPathDP is "..tostring(FixedPathDP)))	
		else
			env.info(("DAWS option FixedPathDP is nil"))
		end				
		if AIEsuppressionDP then
			env.info(("DAWS option AIEsuppressionDP is "..tostring(AIEsuppressionDP)))	
		else
			env.info(("DAWS option AIEsuppressionDP is nil"))
		end		
		if AIEvehicledamageDP then
			env.info(("DAWS option AIEvehicledamageDP is "..tostring(AIEvehicledamageDP)))	
		else
			env.info(("DAWS option AIEvehicledamageDP is nil"))
		end		
		if AIEinfantryCarrierDP then
			env.info(("DAWS option AIEinfantryCarrierDP is "..tostring(AIEinfantryCarrierDP)))	
		else
			env.info(("DAWS option AIEinfantryCarrierDP is nil"))
		end	
		if AIEinfantryCarrierPercDP then
			env.info(("DAWS option AIEinfantryCarrierPercDP is "..tostring(AIEinfantryCarrierPercDP)))	
		else
			env.info(("DAWS option AIEinfantryCarrierPercDP is nil"))
		end	
		if AIEautoartilleryDP then
			env.info(("DAWS option AIEautoartilleryDP is "..tostring(AIEautoartilleryDP)))	
		else
			env.info(("DAWS option AIEautoartilleryDP is nil"))
		end	
		if AIEbaseIADSDP then
			env.info(("DAWS option AIEbaseIADSDP is "..tostring(AIEbaseIADSDP)))	
		else
			env.info(("DAWS option AIEbaseIADSDP is nil"))
		end			
		
	end		
	--]]--
	
	-- load submodules
	--local actiDAWS = function()
		
		env.info(("DAWS mission time is: " .. timer.getAbsTime()))
		
		if DAWS then
		
			if Activate_SaveMission == true then
				if debugProcess == true then
					env.info(("DAWS: loading Save Mission"))
				end

				dofile(moddirectorySM .. "DAWS_saveMission.lua")
			
				if debugProcess == true then
					env.info(("DAWS: Save Mission load done"))
				end
			end
			
			if Activate_AIenhancement == true then
				if debugProcess == true then
					env.info(("DAWS: loading AI enhancement"))
				end						

				dofile(moddirectoryAE .. "DAWS_AIenhancement.lua")

				if debugProcess == true then
					env.info(("DAWS: AI enhancement load done"))
				end
			end
		end
	
	--end
	
	--timer.scheduleFunction(actiDAWS, {}, timer.getTime() + 130)
	
	env.info(("DAWS Package version: " .. MainVersion .. "." .. SubVersion .. "." .. Build .. " loaded"))
	
	
	
	
	
	
	
	
	
	
	
	